package com.steerinfo.meterwork.meterworkimage.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkimage.model.MeterWorkImage;
import com.steerinfo.meterwork.meterworkimage.service.IMeterWorkImageService;
import com.steerinfo.meterwork.meterworkimagetemp.model.MeterWorkImageTemp;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkImage RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-09-19 04:48
 * 类描述
 * 修订历史：
 * 日期：2020-09-19
 * 作者：generator
 * 参考：
 * 描述：MeterWorkImage RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkimages")
public class MeterWorkImageController extends BaseRESTfulController {

    @Autowired
    IMeterWorkImageService meterWorkImageService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkimage:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkImage> list = meterWorkImageService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkimage:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkImage> list = meterWorkImageService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkImage对象创建")
    @ApiImplicitParam(name = "meterWorkImage", value = "详细实体meterWorkImage", required = true, dataType = "MeterWorkImage")
    //@RequiresPermissions("meterworkimage:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkImage model) {
        try {
            MeterWorkImage meterWorkImage = meterWorkImageService.add(model);
            return success(meterWorkImage);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkimage:view")
    @GetMapping(value = "/getById")
    public RESTfulResult get(@RequestParam String id) {
        try {
            MeterWorkImage meterWorkImage = meterWorkImageService.getById(id);
            return success(meterWorkImage);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkImage信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkImage", value = "详细实体meterWorkImage", required = true, dataType = "MeterWorkImage")
    })
    //@RequiresPermissions("meterworkimage:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkImage model) {
        try {
            model.setId(id);
            MeterWorkImage meterWorkImage = meterWorkImageService.modify(model);
            return success(meterWorkImage);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkimage:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkImageService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取图片路径", notes = "获取图片路径")
    @GetMapping(value = "/getUrl")
    public RESTfulResult getUrl(@RequestParam String actualFirstNo) {
        RESTfulResult rm = failed();
        try {
            rm = meterWorkImageService.queryRailwayUrl(actualFirstNo);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setCode("200");
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "获取轨道衡图片路径", notes = "获取轨道衡图片路径")
    @GetMapping(value = "/getRailwayUrl")
    public RESTfulResult getRailwayUrl(@RequestParam String actualFirstNo) {
        RESTfulResult rm = failed();
        try {
            rm = meterWorkImageService.queryUrl(actualFirstNo);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setCode("200");
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "净重数据维护界面、批量处理界面---获取一毛一皮轨道衡图片路径", notes = "批量处理界面---获取一毛一皮轨道衡图片路径")
    @GetMapping(value = "/getRailwayImageUrl")
    public RESTfulResult getRailwayImageUrl(@RequestParam HashMap<String, Object> map) {
        RESTfulResult rm = failed();
        try {
            rm = meterWorkImageService.getRailwayImageUrl(map);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setCode("200");
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "批量处理界面---获取净重（一毛一皮）和空皮轨道衡图片路径", notes = "批量处理界面---获取净重（一毛一皮）、空皮轨道衡图片路径")
    @GetMapping(value = "/getRailwayActualImageUrl")
    public RESTfulResult getRailwayActualImageUrl(@RequestParam HashMap<String, Object> map) {
        RESTfulResult rm = failed();
        try {
            rm = meterWorkImageService.getRailwayActualImageUrl(map);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setCode("200");
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "轨道衡核查界面---获取净重（一毛一皮）和空皮轨道衡图片路径", notes = "批量处理界面---获取净重（一毛一皮）、空皮轨道衡图片路径")
    @GetMapping(value = "/getAllRailwayImageUrl")
    public RESTfulResult getAllRailwayImageUrl(@RequestParam HashMap<String, Object> map) {
        RESTfulResult rm = failed();
        try {
            rm = meterWorkImageService.getAllRailwayImageUrl(map);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setCode("200");
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "C#创建", notes = "根据MeterWorkImage对象创建")
    @PostMapping(value = "/doSaveWf", produces = "application/json;charset=UTF-8")
    public RESTfulResult doSaveWf(@RequestBody MeterWorkImage model) {
        try {
            return meterWorkImageService.doSaveWf(model);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#创建", notes = "根据MeterWorkImage对象创建")
    @PostMapping(value = "/doSaveRailwayWf", produces = "application/json;charset=UTF-8")
    public RESTfulResult doSaveRailwayWf(@RequestBody MeterWorkImage model) {
        try {
            return meterWorkImageService.doSaveRailwayWf(model);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#动态衡图片修改", notes = "根据MeterWorkImage对象创建")
    @PostMapping(value = "/updateDynamicImage", produces = "application/json;charset=UTF-8")
    public RESTfulResult updateDynamicImage(@RequestBody MeterWorkImage model) {
        try {
            return meterWorkImageService.updateDynamicImage(model);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
